-- SQL QA
--[1] ϼ Խ(Notice) ̺ 
--Drop Table dbo.Notice
Create Table dbo.Notice
(
	Num Int Identity(1, 1) Not Null Primary Key, 		--ȣ
	Name VarChar(25) Not Null,				--̸
	Email VarChar(100) Null, 				--̸	
	Title VarChar(150) Not Null,				--
	PostDate DateTime Default GetDate() Not Null,		--ۼ	
	PostIP VarChar(15) Not Null,				--ۼIP
	Content Text Not Null,					--
	Password VarChar(20) Null,				--йȣ
	ReadCount Int Default 0,				--ȸ
	Encoding VarChar(10) Not Null,				--ڵ(HTML/Text)
	Homepage VarChar(100) Null,				--Ȩ
	ModifyDate DateTime Null,				--	
	ModifyIP VarChar(15) Null,				--IP
	FileName VarChar(255) Null,			--ϸ
	FileSize Int Null,					--ũ
	DownCount Int Default 0,				--ٿ	
	Ref Int Not Null,					--(θ)
	Step Int Default 0,					--亯()
	RefOrder Int Default 0,				--亯
	AnswerNum Int Default 0,			--亯
	ParentNum Int Default 0,					--θ۹ȣ
	CommentCount Int Default 0,			--ڸƮ
	Category VarChar(10) Null			--īװ
)
Go

-- Write.aspx
--[2] ϼ Խ(Notice)  ۼϴ  ν : procWriteNotice
Create Proc dbo.procWriteNotice
	@Name VarChar(25), 
	@Email VarChar(100), 
	@Title VarChar(150), 
	@PostIP VarChar(15), 
	@Content Text, 
	@Password VarChar(20), 
	@Encoding VarChar(10), 
	@Homepage VarChar(100),
	@Ref Int,
	@FileName VarChar(255),
	@FileSize Int
As
--With Encryption
	Insert Notice
		(Name, Email, Title, PostIP, Content, Password, Encoding, Homepage, Ref, FileName, FileSize)
	Values
		(@Name, @Email, @Title, @PostIP, @Content, @Password, @Encoding, @Homepage, @Ref, @FileName, @FileSize)
Go

-- List.aspx
--[3] ϼ Խ(Notice) ͸ о  ν : procListNotice : ݵ 
Create Procedure dbo.procListNotice
As
	Select * From Notice Order By Ref Desc, RefOrder Asc
Go

-- View.aspx
--[4] ȸ ִ  ν : procUpdateReadCount
Create Proc dbo.procUpdateReadCountNotice
	@Num Int
As
	Update Notice Set ReadCount = ReadCount + 1 Where Num = @Num
Go

--[5] ش   о  ν : procViewNotice
Create Procedure dbo.procViewNotice
	@Num Int
As
	Select * From Notice Where Num = @Num
Go

--Reply.aspx
--[6] ϼ Խ(Notice)  亯ϴ  ν : procReplyNotice
--Drop Proc dbo.procReplyNotice
Create Proc dbo.procReplyNotice
	@Name VarChar(25), 
	@Email VarChar(100), 
	@Title VarChar(150), 
	@PostIP VarChar(15), 
	@Content Text, 
	@Password VarChar(20), 
	@Encoding VarChar(10), 
	@Homepage VarChar(100),
	@Ref Int,
	@Step Int,
	@RefOrder Int,
	@ParentNum Int,
	@FileName VarChar(255),
	@FileSize Int
As
--With Encryption
	Insert Notice
		(Name, Email, Title, PostIP, Content, Password, Encoding, Homepage, Ref, Step, RefOrder, ParentNum, FileName, FileSize)
	Values
		(@Name, @Email, @Title, @PostIP, @Content, @Password, @Encoding, 
		@Homepage, @Ref, @Step, @RefOrder, @ParentNum, @FileName, @FileSize)
Go

--[7] ⺻  Ʒ   ¡ ڵ ׷̵
--Drop Proc dbo.procListNotice
Create Proc dbo.procListNoticeAdvancedPaging
	@PageSize Int,
	@intPage Int
As
	Set @intPage = @intPage * @PageSize
	Exec
	(
		'Select Top ' + @PageSize + ' * 
		From Notice 
		Where Num Not In
			(
				Select Top ' + @intPage + ' Num From Notice Order By Ref Desc, RefOrder Asc 
			)
		Order By Ref Desc, RefOrder Asc '
	)
Go

--[8] Notice ̺ ִ ڵ  ϴ  ν
Create Proc dbo.procGetCountNotice
As
	Select Count(*) From Notice
Go

--[9] Modify.aspx, Delete.aspx
-- ش ۿ  йȣ о  ν : procReadPasswordNotice
Create Proc dbo.procReadPasswordNotice
	@Num Int
As 
	Select Password From Notice Where Num = @Num
Go

--[10] ش    ν
-- 亯  Ʈϰ  . ణ ̿ϼ
--Drop Proc dbo.procDeleteNotice
Create Proc dbo.procDeleteNotice
	@Num Int
As

Declare @AnswerNum Int
Declare @RefOrder Int
Declare @Ref Int
Declare @ParentNum Int

Select
	@AnswerNum = AnswerNum,
	@RefOrder = RefOrder,
	@Ref = Ref,
	@ParentNum = ParentNum
From
	Notice
Where Num = @Num

If @AnswerNum = 0
	Begin
		If @RefOrder > 0 
		Begin
			UPDATE Notice SET RefOrder = RefOrder - 1 WHERE Ref = @Ref AND RefOrder > @RefOrder
			UPDATE Notice SET AnswerNum = AnswerNum - 1 WHERE Num = @ParentNum
		End
		Delete Notice Where Num = @Num
		Delete Notice WHERE Num = @ParentNum AND ModifyIP = '((DELETED))' AND AnswerNum = 0--   Լ ȣ		
	End
Else
	Begin
		Update Notice Set Name = '(Unknown)', Email = NULL, Password = NULL,
				Title = '( Դϴ.)', Content = '( Դϴ.  亯 ԵǾ ֱ  븸 Ǿϴ.)',
				ModifyIP = '((DELETED))', FileName = NULL, FileSize = NULL, CommentCount = 0
		Where Num = @Num  
	End
Go

-- Modify.aspx
--[11] ش  ϴ  ν : procUpdateNotice
Create Proc dbo.procUpdateNotice
	@Name VarChar(25), 
	@Email VarChar(100), 
	@Title VarChar(150), 
	@ModifyIP VarChar(15), 
	@ModifyDate DateTime,
	@Content Text, 
	@Encoding VarChar(10), 
	@Homepage VarChar(100),
	@Num Int
As
	Update Notice 
	Set 
		Name = @Name,
		Email = @Email,
		Title = @Title,
		ModifyIP = @ModifyIP,
		ModifyDate = @ModifyDate,
		Content = @Content,
		Encoding = @Encoding,
		Homepage = @Homepage
	Where Num = @Num
Go

--Search.aspx
--[12]Drop Proc dbo.procSearchNotice
Create Proc dbo.procSearchNotice
As
	Select * From Notice Order By Num Desc
Go
